unit MailForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Tabs, ListNav, Buttons, Mask, ToolEdit,registry,
  Psock, NMsmtp, ComCtrls,IniFiles;

type
  TFormMail = class(TForm)
    EmailPrivate: TLabel;
    LabelSMTP: TLabel;
    EmailEdit: TEdit;
    EditSMTP: TEdit;
    DisconnectBtn: TBitBtn;
    CloseBtn: TBitBtn;
    FilenameEdit: TFilenameEdit;
    Label1: TLabel;
    AboutBtn: TBitBtn;
    NMSMTP1: TNMSMTP;
    Label2: TLabel;
    FromEdit: TEdit;
    Label18: TLabel;
    StatusBar: TStatusBar;
    SendBtn: TBitBtn;
    ConnectBtn: TBitBtn;
    ProgressBar: TProgressBar;
    procedure AboutBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FilenameEditAfterDialog(Sender: TObject; var Name: String;
      var Action: Boolean);
    procedure NMSMTP1AttachmentNotFound(Filename: String);
    procedure NMSMTP1Status(Sender: TComponent; Status: String);
    procedure NMSMTP1Success(Sender: TObject);
    procedure SendBtnClick(Sender: TObject);
    procedure ConnectBtnClick(Sender: TObject);
    procedure DisconnectBtnClick(Sender: TObject);
    procedure NMSMTP1PacketSent(Sender: TObject);
    procedure NMSMTP1ConnectionRequired(var Handled: Boolean);
    procedure NMSMTP1Connect(Sender: TObject);
    procedure NMSMTP1Disconnect(Sender: TObject);
    procedure FilenameEditChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Reg:TRegistry;
    Ini:TIniFile;
    FileName,AdditionalInfo:String[127];
    isText:boolean;
    FromText,UserId,Target:string[127];
  end;

var
  FormMail: TFormMail;

implementation

uses AboutUPL;

{$R *.DFM}

procedure TFormMail.AboutBtnClick(Sender: TObject);
begin
 try
 AboutDlg:=TAboutDlg.Create(self);
 AboutDlg.ShowModal;
 finally
 AboutDlg.Destroy;
 end;
end;

procedure TFormMail.FormCreate(Sender: TObject);
var ProfileKey,SmtpServer,SmtpReply,SmtpDispAcc:String;
begin
 {registry loading of email address and default smtp}
 {rmczerw@icm.edu.pl}
try
 Ini:=nil;
 Reg:=TRegistry.Create;
 Reg.Rootkey:=Hkey_Current_User;
 Reg.OpenKeyReadOnly('\Software\Microsoft\Internet Account Manager');
 Profilekey:=Reg.ReadString('Default Mail Account');
 Reg.OpenKeyReadOnly('Accounts\'+ProfileKey);
 SmtpServer:=Reg.ReadString('SMTP Server');
 SmtpReply:=Reg.ReadString('SMTP Email Address');
 FromText:=SmtpReply;
 SmtpDispAcc:=Reg.ReadString('SMTP Display Name');
 UserID:=Reg.ReadString('POP3 User Name');
 EmailEdit.Text:=SmtpReply;
 EditSMTP.Text:=SmtpServer;
 FromEdit.Text:=SmtpDispAcc;
 Reg.Openkey('\Software\GDA\DSP',true);
 Target:=Reg.ReadString('UPLOADS');
 if Target='' then
  begin
   Target:='rmczerw@icm.edu.pl';
   Reg.Writestring('UPLOADS',TARGET);
  end;
finally
 Reg.Free;
end;
end;

procedure TFormMail.FilenameEditAfterDialog(Sender: TObject;
  var Name: String; var Action: Boolean);
begin
 Caption:=Name;
 ini:=TiniFile.Create(name);
 EmailEdit.Text:=Ini.ReadString('Uploader_1','Author E-mail','');
 if EmailEdit.Text='' then EmailEdit.Text:=FromText;
 FromEdit.Text:=Ini.readString('Uploader_1','Author name','Error');
 FileName:=Ini.ReadString('DSP upload','File Name','');
 AdditionalInfo:=Ini.ReadString('DSP upload','Additional info','');
 isText:=pos('T',AdditionalInfo)=1;
 ini.Free;
 ini:=nil;
end;

procedure TFormMail.NMSMTP1AttachmentNotFound(Filename: String);
begin
 MessageDlg(('Attachment file not found '+filename),MtError,[MbOk],0);
end;

procedure TFormMail.NMSMTP1Status(Sender: TComponent; Status: String);
begin
 if sender<>nil then
 Statusbar.SimpleText:=Status;
end;

procedure TFormMail.NMSMTP1Success(Sender: TObject);
begin
 MessageDlg('Upload Sucessful',mtInformation,[mbok],0);
end;

procedure TFormMail.SendBtnClick(Sender: TObject);
var f:String;
begin
 With nmsmtp1.PostMessage do
  begin
   FromName:=FromEdit.Text;
   ToAddress.Clear;
   ToAddress.Add('rmczerw@icm.edu.pl');
   FromAddress:=FromText;
   ReplyTo:=EmailEdit.Text;
   LocalProgram:='GDA Uploader Version 1 (DSP)';
   Attachments.Clear;
   Attachments.Add(FilenameEdit.Text);
   Attachments.Add(FileName);
   if isText
   then
    begin
      f:=extractFileName(FileName);
      system.delete(f,(pos('.',f)+1),(Length(f)-pos('.',f)));
      f:=f+'txt';
    end
   else
    begin
      f:=extractFileName(FileName);
      system.delete(f,(pos('.',f)+1),(Length(ExtractFileExt(f))));
      f:=f+'htm';
      end;
   Attachments.add(extractfilePath(filename)+f);
   Date:=DateTimeToStr(Now);
   ToAddress.Clear;
   ToAddress.Add(Target);
  end;
 NMSMTP1.USERID:=UserID;
 NMSMTP1.Host:=EditSMTP.Text;
 NMSMTP1.Sendmail;
end;

procedure TFormMail.ConnectBtnClick(Sender: TObject);
begin
 NmSMTP1.CONNECT;
end;

procedure TFormMail.DisconnectBtnClick(Sender: TObject);
begin
 nmsmtp1.Disconnect;
end;

procedure TFormMail.NMSMTP1PacketSent(Sender: TObject);
begin
 ProgressBar.Max:=NMSMTP1.BytesTotal;
 ProgressBar.Position:=NMSMTP1.BytesSent;
end;

procedure TFormMail.NMSMTP1ConnectionRequired(var Handled: Boolean);
begin
 if mrYes=MessageDlg('Connection Required do you wish to connect ?',MtConfirmation,[mbyes,mbno],0)
  then NMSMTP1.Connect;
  handled:=true;
end;

procedure TFormMail.NMSMTP1Connect(Sender: TObject);
begin
 Color:=clred;
end;

procedure TFormMail.NMSMTP1Disconnect(Sender: TObject);
begin
 color:=clbtnFace;
end;

procedure TFormMail.FilenameEditChange(Sender: TObject);
begin
 SendBtn.Enabled:=FileNameEdit.Text>'';
end;

end.
 